/*********************************************************************************************************************/

// These are the filenames that your mod will use.  Please *don't* remove those "."s!
#define FILEN_CONFIG     "config."
#define FILEN_VGASW      "vswap."
#define FILEN_VGAH       "vgahead."
#define FILEN_VGAGR      "vgagraph."
#define FILEN_VGAD       "vgadict."
#define FILEN_MAPH       "maphead."
#define FILEN_MAPGM      "gamemaps."
#define FILEN_AUDHEAD    "audiohed."
#define FILEN_AUDT       "audiot."
#define FILEN_DEM        "demo?."    // I recommend you leave the "?" alone, and just change the first four letters.
#define FILEN_HELPART    "HELPART."  // Just change the first seven letters of the name to avoid problems.
#define FILEN_ENDART     "ENDART1."  // Change just the first six letters of the name to avoid problems.
#define FILEN_INTART     "INTART00." // Change just the first six letters for the AUTOINTER feature.

#define FILEN_EXMAPN     "LEVELNAM." // For EXTERNMAPN;  gives names for each map in the game.

// For v1.0 files or Blake Stone only
#define FILEN_MAPT       "maptemp."

// Your mod's three-character extension (as opposed to WL6 or SOD)
//
// 60-level extension
#define FILEN_60LEV      "wl6"

// 21-level extension
#define FILEN_21LEV      "sod"

/*********************************************************************************************************************/
// Remove the "//" mark before each option to enable it;  add "//" at the beginning to disable it again.  For example,
// enabling the line "#define WOLF3D14APOGEE" will compile v1.4 of the Apogee commercial release of Wolf3D.
//
// Enable one of the lines below to get things compiling

//#define WOLF3D14APOGEE         // Wolf3D v1.4, 60 levels, with bigger VGAGRAPH (usually has "ReadThis!" enabled)
//#define WOLF3D14GT             // Wolf3D v1.4, 60 levels, with smaller VGAGRAPH (usually has "ReadThis!" disabled)
#define WOLF3D14SHAREWARE      // Wolf3D v1.4, Shareware version with 10 levels and "ReadThis!"
//#define WOLF3D11WITH60LEV      // Wolf3D v1.1, commercial version with 60 levels and "Read This!"
//#define WOLF3D11WITH10LEV      // Wolf3D v1.1, Shareware version with 10 levels and "Read This!"
//#define WOLF3D10WITH10LEV      // Wolf3D v1.0, Shareware version with 10 levels and "Read This!"
//#define SPEAR21LEVELS          // Spear Of Destiny, full 21-level version
//#define SPEAR2LEVELS           // Spear Of Destiny, 2-level demo version
/*********************************************************************************************************************/
// Other options

//#define ENABLEREADTHIS        // Enable the "Read This!" feature in the main menu

//#define USE_HIRES           // Enables high resolution textures and sprites (128x128)

//#define USE_FLOORCEILINGTEX   // Enables floor & ceiling textures stored in the 3rd mapplane (see wl_floorceiling.cpp)

#define DEBUGKEYS             // Comment this out to compile without the Tab debug keys

//#define WEAPONBOBBLE          // BT's gun-bobbing code

//#define MYMODDEMO             // Make "demo" version with one episode and a small number of levels

//#define BLAKEDOORS            // Blake Stone-style Double doors (Haasboy and Adam Biser)

//#define SEAMLESSLEVELS        // Enable Seamless Levels Feature in non-Spear mode

//#define USE_DIR3DSPR          // Enables Directional 3-D Sprites
//#define USE_FEATUREFLAGS      // Enables the level feature flags (shading, weather effects, and so on)
//#define EXTERNMAPN            // Shows map's name in Get Spyched! screen, from LEVELNAM.???
//#define NOSPEARQUIZ           // Skip the Copy Protection routine in Spear Of Destiny
#define USEGUARDBLOCKERS      // Enable code to block guards from moving into areas you don't want them (MCS)
#define INGAMEMESSAGES        // Show messages on the screen when "things happen" (Text found in _MESSAGES.H) (WSJ)
#define WALLCODE              // Code to disable wall sounds from menu
#define KILLIDCONTEST         // Don't do "secret codes" from Id's cancelled contest
//#define CUSTOMPALETTE         // Use customized palette CUSTOMPAL.INC instead of Wolf3D or SOD palette
//#define AARDWOLFISAMMO        // Use "Say Aardwolf" sprite as SOD's ammo box
//#define ENABLEMENUBACKG       // In Wolf3D, menu uses background from VGAGRAPH

//#define WALLPATCH             // Enables the Wall Patches code by Haasboy, Adam Biser, and BT
//#define ANIMSTATICOBJECTS     // Enables Animated Static Objects
//#define NOGETPSYCHEDLINE      // Don't draw the "growing red line" in the "Get Psyched!" screen
//#define NOSIGNONSCREEN        // Don't do sign-on screen
//#define NOPRESSAKEY           // Don't do the "Press a key" part in the sign-on screen
#define FLEXIBLENUMCHUNKS     // Don't be so picky about the number of chunks in the VGAGRAPH
//#define NOPG13SCREEN          // Don't do the PC-13 screen
#define DOWALLSOUNDS          // Do sounds when you hit a wall, or when you try to push a non-Pushwall
#define USEENDLEVELTILE       // Enable the ENDLEVELTILE marker (see below)
#define GAMEDIFFICULTYMSG     // Enable "comments" for game's difficulties 1 through 4 (Chris)
//#define REMOVEINTERTEXT       // No text screens in Wolf3D after completing an episode or the game
//#define SMART_FLOORCEILINGTEX // Draw floor/ceiling textures only if square (0,0) of Plane 2 = 0
//#define REMOVETEDLEVEL        // Disable TEDLEVEL feature
//#define AUTOINTER             // Enable intermission text in between levels
//#define STATIONARYDOGS        // Enable Stationary Dogs code (AReyeP)
//#define SSALWAYSDROPSGUN      // SS always drops Gun #3 when he dies
//#define SMARTWEAPONSKIP       // Don't get weapon if you have it, and ammo is full
//#define HARMFULSTOVE          // Make Stove harm BJ when he "Uses" it

#define DOOMMUSIC             // Don't have music restart when quick-loading or "dying";  like Doom did, basically
#define NOLEVMUSICFORDEMO     // Don't play the in-game music in self-running demos (only works with DOOMMUSIC feature)

#define DOPISTOLSND           // Play ATKPISTOLSND in the Main Menu
//#define MENUCLICK             // Give ESCPRESSEDSND a digitized "gun click" sound from the VSWAP
//#define KNIFEDIGITIZED        // Have Weapon #1 use a digitized sound
//#define SBSOUNDBJDEAD         // Use digitized sound when BJ "dies"
//#define WEAPON4PICKUPSND      // Use digitized sound for GETGATLINGSND in non-Spear mode

//#define EXTRADOORTYPES        // Use new unlocked doors 1 and 2
//#define UNIQUELOCKED          // Each locked door uses a different texture
//#define DOORSIDECODE          // Ripper's code for different door sides

#define CHRISSRAYCBUGFIX      // Chris's raycaster bugfix to hide "wall gaps"

//#define DOTEXTFROMFILES         // Use external ART files
//#define DODEMOSFROMFILES        // Run demos from DEMO? files

#define PLAYDEMOLIKEORIGINAL  // When playing or recording demos, several bug fixes do not take
                              // effect to let the original demos work as in the original Wolf3D v1.4
                              // (actually better, as the second demo rarely worked)

#define STARTAMMO          8  // The ammo you start out with in a new game or when you "die"
#define AMMOMAXIMUM       99  // The maximum amount of ammo allowed in the game

#define NUMBEROFACTORSLIMIT          150  // maximum number of nazis, bosses, etc. on the map
#define NUMBEROFSTATICOBJECTSLIMIT   500  // maximum number of lamps, ammo, bonus, etc.
#define MAXIMUMOFVISIBLEOBJECTS      250  // maximum number of visible objects on the screen

// Ths source code uses Chris's 128+ Doors code, so changing the two numbers below actually doesn't do anything.
// It's just placed here so you know what the limits are for doors and wall types.  :-)
#define NUMBEROFDOORSLIMIT           2048 // maximum number of sliding doors (Chris)
#define MAXIMUMOFWALLSLIMIT          1024 // maximum number of wall types (Chris)
/*********************************************************************************************************************/
// Fine-tune your mod with these options

// Music order - consult file "_music.h"

// What level the Secret Elevator is found, from Episodes 1 to Episode 6.  Note: If you're using the Seamless Levels
// feature in the commercial versions, modify the Spear Secret Level numbers instead.
#define SECRETELEVFROME1      1
#define SECRETELEVFROME2      1
#define SECRETELEVFROME3      7
#define SECRETELEVFROME4      3
#define SECRETELEVFROME5      5
#define SECRETELEVFROME6      3

// What levels in Spear the Secret Elevators are found.  This is also used if the Seamless Levels feature
// is enabled in the 60-level version (not the Shareware version).
//
// No need to go beyond SODSECRLEV2FROM if there's only two Secret Levels, like the original SOD.
#define SODSECRLEV1FROM       4
#define SODSECRLEV2FROM       12
#define SODSECRLEV3FROM       0
#define SODSECRLEV4FROM       -1
#define SODSECRLEV5FROM       -2
#define SODSECRLEV6FROM       -3


#define PUSHWALLSQUARES       2     // How many squares a Pushwall should move

#define DOORSPEED             10    // Speed the doors open and close;  10 is the default, and
                                    // 11 is faster
#define PUSHWALLSPEED         1     // Speed the Pushwalls move;  default is 1;  legal values are
                                    // 1 through 16

// Episodes 1 through 6 will always use Level 10 as the secret level *unless* you have Seamless Levels enabled.

// Define which level is the first Secret Level for SOD or the Seamless Levels
#define FIRSTSPEARSECRETLEVEL 19

// Define which level the Spear Of Destiny "warps" the player to
#define WARPTOANGELOFDEATHLEV 21

/*********************************************************************************************************************/
// Ceiling colors - consult file "_ceilingcolors.h"
//
// Floor color
#define FLOORCOLOR      0x19  // Color of the "floor" when no floor textures are drawn
/*********************************************************************************************************************/
// Par times - consult file "_partimes.h"
